/*==================================================================================================

Copyright (c) 2007 UGS
Unpublished - All rights reserved

====================================================================================================
File description:

Filename: setDateArrayOperationDispatcher.hxx
Module  : extensionframework

This is the root interface class of the setDateArrayOperationDispatcher. It contains of all the generic methods
for setDateArrayOperationDispatcher that can be reused by the derived classes.

====================================================================================================
Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef setDateArrayOperationDispatcher_HXX
#define setDateArrayOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class setDateArrayOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::setDateArrayOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
public:
    setDateArrayOperationDispatcher();
    virtual ~setDateArrayOperationDispatcher();
    static OperationDispatcher *constructor();

    void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

    void setDateArrayPreConditions( Teamcenter::BusinessObject* obj, const std::vector<date_t>& dateValues,  const std::vector<int>* isNullVals ) const;
    void setDateArrayPreActions( Teamcenter::BusinessObject* obj, const std::vector<date_t>& dateValues,  const std::vector<int>* isNullVals  ) const;
    void setDateArrayBaseAction( Teamcenter::BusinessObject* obj, const std::vector<date_t>& dateValues,  const std::vector<int>* isNullVals  ) const;
    void setDateArrayPostActions( Teamcenter::BusinessObject* obj, const std::vector<date_t>& dateValues,  const std::vector<int>* isNullVals  ) const;

    // Project 011450 changes
    void setDateArrayPreConditions(  METHOD_message_t* msgData, int num, const date_t* dateValues,  const logical* isNullVals ) const;
    void setDateArrayPreActions(  METHOD_message_t* msgData, int num, const date_t* dateValues,  const logical* isNullVals ) const;
    void setDateArrayPostActions(  METHOD_message_t* msgData, int num, const date_t* dateValues,  const logical* isNullVals ) const;
    void setDateArrayBaseAction(  METHOD_message_t* msgData, int num, const date_t* dateValues,  const logical* isNullVals ) const;

    void setDateArray( Teamcenter::BusinessObject* obj, const std::vector<date_t>& dateValues,  const std::vector<int>* isNullVals  ) const;

    void execute(Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
    void execute( tag_t objTag, va_list  args ) const;
    void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


    //Fix compiler warnings that were hiding virtual functions
    using Teamcenter::OperationDispatcher::executePreConditions;
    using Teamcenter::OperationDispatcher::executePreActions;
    using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //setDateArrayOperationDispatcher_HXX
